Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_utils.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_utils.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_utils.f90	(revision 2528)
@@ -0,0 +1,131 @@
+module m_dom_utils
+
+  use m_dom_types
+  use m_dom_element
+  use m_dom_document
+  use m_dom_node
+  use m_dom_namednodemap
+  use m_dom_debug
+  use m_strings
+
+  use flib_wxml
+
+  public :: dumpTree
+  public :: xmlize
+
+  private
+
+CONTAINS
+
+  subroutine dumpTree(startNode)
+
+    type(fnode), pointer :: startNode   
+
+    character(len=50) :: indent = " "
+    integer           :: indent_level
+    type(string)      :: s
+
+    indent_level = 0
+
+    call dump2(startNode)
+
+  contains
+
+    recursive subroutine dump2(input)
+      type(fnode), pointer :: input
+      type(fnode), pointer :: temp     
+      temp => input
+      do while(associated(temp))
+         s = getNodeName(temp)
+         write(*,'(3a,i3)') indent(1:indent_level), &
+                        char(s), " of type ", &
+                        getNodeType(temp)
+         if (hasChildNodes(temp)) then
+            indent_level = indent_level + 3
+            call dump2(getFirstChild(temp))
+            indent_level = indent_level - 3
+         endif
+         temp => getNextSibling(temp)
+      enddo
+
+    end subroutine dump2
+
+  end subroutine dumpTree
+!----------------------------------------------------------------
+
+  subroutine xmlize(startNode,fname)
+
+    type(fnode), pointer :: startNode   
+    character(len=*), intent(in) :: fname
+
+    type(xmlf_t)  :: xf
+    type(string)  :: s, sv, sn       ! to avoid memory leaks
+
+    call xml_OpenFile(fname,xf)
+    call dump_xml(startNode)
+    call xml_Close(xf)
+
+  contains
+
+    recursive subroutine dump_xml(input)
+      type(fnode), pointer         :: input
+!
+!     Just this node and its descendants, no siblings. 
+!     Of course, the document node has only children...
+!
+      type(fnode), pointer         :: node, attr
+      type(fnamedNodeMap), pointer :: attr_map
+      integer  ::  i
+
+      node => input
+      do
+         if (.not. associated(node)) exit
+         select case (getNodeType(node))
+
+          case (DOCUMENT_NODE)
+
+             call xml_AddXMLDeclaration(xf)
+             if (hasChildNodes(node)) call dump_xml(getFirstChild(node))
+
+          case (ELEMENT_NODE)
+
+             s = getNodeName(node)
+             call xml_NewElement(xf,char(s))
+             attr_map => getAttributes(node)
+             do i = 0, getLength(attr_map) - 1
+                attr => item(attr_map,i)
+                sn = getNodeName(attr)
+                sv = getNodeValue(attr)
+                call xml_AddAttribute(xf, char(sn),char(sv))
+             enddo
+             if (hasChildNodes(node)) call dump_xml(getFirstChild(node))
+             s = getNodeName(node)
+             call xml_EndElement(xf,char(s))
+
+          case (TEXT_NODE)
+             
+             s = getNodeValue(node)
+             call xml_AddPcdata(xf,char(s))
+
+          case (CDATA_SECTION_NODE)
+             
+             s = getNodeValue(node)
+             call xml_AddCdataSection(xf,char(s))
+
+          case (COMMENT_NODE)
+             
+             s = getNodeValue(node)
+             call xml_AddComment(xf,char(s))
+
+        end select
+        if (associated(node,StartNode)) exit  ! In case we request the 
+                                              ! dumping of a single element,
+                                              ! do not do siblings
+        node => getNextSibling(node)
+     enddo
+
+    end subroutine dump_xml
+
+  end subroutine xmlize
+
+end module m_dom_utils
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/CHANGES
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/CHANGES	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/CHANGES	(revision 2528)
@@ -0,0 +1,28 @@
+April 28, 2004
+
+* New optional argument "record_size" in open_xmlfile. The default record 
+length is 65536, but for overly long lines it might be necessary to specify
+a larger size.
+
+* Wrote "init_" routines to avoid undefined status for the components
+of the buffer, dictionary, and elstack derived types (Fortran90 restriction). 
+They are called just once at the beginning of execution.
+
+The "reset_" routines just zero out the counters in the derived
+types. This leads to substantial savings in overhead.
+
+* Avoided when possible the allocation of temporaries (mostly strings) by
+the compilers. This was particularly acute in the "action" records. The
+typical idiom:
+
+	action =trim("Reading character in name: " // c)
+
+forced the allocation of a temporary.  The number of compiler allocations
+(at least with NAG) has dropped down to just those needed in the processing
+of entities.
+
+* Put the explicit module dependencies in the makefile.
+
+* Increased the standard size of the buffers and dictionaries.
+***** The program now stops when those sizes are not enough.
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/Developer.Guide
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/Developer.Guide	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/Developer.Guide	(revision 2528)
@@ -0,0 +1,61 @@
+Developer Notes:
+
+The parser is built on several levels:
+
+1. The closest to the user.
+
+   Modules:  m_xml_parser: The main module
+             m_error     : Basic error handling
+
+2. An intermediate layer.
+
+   Modules: m_fsm  (A finite-state machine to parse the input)
+
+3. A layer defining basic data structures and file interfaces:
+
+   Modules: m_reader:  File interface and character handling as per XML specs.
+	    m_buffer:  Basic homemade "variable length string", with some
+                       limitations (size, of course), but avoiding the
+                       use of dynamic structures for now.
+	    m_dictionary: Simple, not dynamic.
+            m_charset: A simple hashing method for sets of characters.
+	    m_elstack: Simple stack to check well-formedness.
+	    m_entities: Entity replacement utilities.
+
+4. Something which does not really belong in the parser but which
+   is useful to massage the data extracted from the file:
+
+	m_converters: Routines to turn pcdata chunks into numerical arrays
+
+
+There are obviously a number of hardwired limitations, which should be
+removed in a later version:
+
+* Buffer size in buffer_t definition. This is not as serious as it
+  looks. Only long unbroken pcdata sections and overly long attribute
+  names or values will be affected. Long SGML declarations and comments
+  might be truncated, but they are not relevant anyway.
+
+* Maximum number of attributes in an element tag (set in m_dictionary)
+
+While the parser does not use any variable-length strings (to keep it
+compatible with existing Fortran90 compilers) or dynamical data
+structures for attribute dictionaries, etc, such improvements could be
+incorporated almost as drop-in replacements for existing sub-modules.
+
+
+The coding style is that of the F subset of Fortran90. I strongly
+believe that it makes for better coding and fewer errors.
+Go to http://www.fortran.com/imagine1/ and get a feel for it. You can
+download free implementations for Linux and Windows, or get an
+inexpensive CD+Book combination to help support the project. Of course,
+F *is* Fortran, so you can always compile it with a Fortran compiler.
+
+
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/TODO
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/TODO	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/TODO	(revision 2528)
@@ -0,0 +1,7 @@
+Things to do:
+
+* Make buffer pseudo-dynamical to avoid limitations.
+* Insert code to deal with XML declarations (really processing instructions)
+  which are not of the form
+  
+ <?name  pseudo_att_name="pseudo_att_value" .... ?>
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/flib_sax.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/flib_sax.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/flib_sax.f90	(revision 2528)
@@ -0,0 +1,19 @@
+module flib_sax
+
+!
+! Stub module to gather all the functionality needed by the user
+! 
+! In future m_dictionary and m_converters could be exported by
+! other parts of a more general fortran library.
+!
+! m_xml_error is necessary in order to use a custom error handler.
+!
+use m_dictionary
+use m_xml_parser
+use m_converters
+use m_xml_error
+
+public
+
+end module flib_sax
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_buffer.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_buffer.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_buffer.f90	(revision 2528)
@@ -0,0 +1,200 @@
+module m_buffer
+
+!
+! At this point we use a fixed-size buffer. 
+! Note however that buffer overflows will only be
+! triggered by overly long *unbroken* pcdata values, or
+! by overly long attribute values. Hopefully
+! element or attribute names are "short enough".
+! There is code in m_fsm to avoid buffer overflows
+! caused by pcdata with whitespace.
+!
+! In a forthcoming implementation it could be made dynamical...
+!
+integer, parameter, public   :: MAX_BUFF_SIZE  = 10000
+integer, parameter, private  :: BUFF_SIZE_WARNING  = 900
+
+!
+
+type, public  :: buffer_t
+private
+      integer                       :: size
+      character(len=MAX_BUFF_SIZE)  :: str
+end type buffer_t
+
+public :: add_to_buffer
+public :: print_buffer, str, len       !! , char
+public :: operator (.equal.)
+public :: buffer_nearly_full, reset_buffer, init_buffer
+public :: buffer_to_character
+
+
+!----------------------------------------------------------------
+interface add_to_buffer
+      module procedure add_str_to_buffer
+end interface
+private :: add_char_to_buffer, add_str_to_buffer
+
+interface operator (.equal.)
+      module procedure compare_buffers, compare_buffer_str, &
+             compare_str_buffer
+end interface
+private :: compare_buffers, compare_buffer_str, compare_str_buffer
+
+interface str
+      module procedure buffer_to_str
+end interface
+interface char                 ! Experimental
+      module procedure buffer_to_str
+end interface
+private :: buffer_to_str
+
+interface len
+   module procedure buffer_length
+end interface
+private :: buffer_length
+
+CONTAINS
+!==================================================================
+
+!----------------------------------------------------------------
+function compare_buffers(a,b) result(equal)     ! .equal. generic
+type(buffer_t), intent(in)  :: a
+type(buffer_t), intent(in)  :: b
+logical                     :: equal
+
+equal = ((a%size == b%size) .and. (a%str(1:a%size) == b%str(1:b%size)))
+
+end function compare_buffers
+
+!----------------------------------------------------------------
+function compare_buffer_str(buffer,str) result(equal) ! .equal. generic
+type(buffer_t), intent(in)   :: buffer
+character(len=*), intent(in) :: str
+logical                      :: equal
+
+equal = (buffer%str(1:buffer%size) == trim(str))
+
+end function compare_buffer_str
+
+!----------------------------------------------------------------
+function compare_str_buffer(str,buffer) result(equal) ! .equal. generic
+character(len=*), intent(in) :: str
+type(buffer_t), intent(in)   :: buffer
+logical                     :: equal
+
+equal = (buffer%str(1:buffer%size) == trim(str))
+
+end function compare_str_buffer
+
+!----------------------------------------------------------------
+subroutine add_char_to_buffer(c,buffer)
+character(len=1), intent(in)   :: c
+type(buffer_t), intent(inout)  :: buffer
+
+integer   :: n
+buffer%size = buffer%size + 1
+n = buffer%size
+
+if (n> MAX_BUFF_SIZE) then
+!!  RETURN
+!
+!  It will only affect long comments and sgml declarations
+   STOP "sax 1 Buffer overflow: long unbroken string of pcdata or attribute value..."
+endif
+
+buffer%str(n:n) = c
+end subroutine add_char_to_buffer
+
+!----------------------------------------------------------------
+subroutine add_str_to_buffer(s,buffer)
+character(len=*), intent(in)   :: s
+type(buffer_t), intent(inout)  :: buffer
+
+integer   :: n, len_s, last_pos
+
+len_s = len(s)
+last_pos = buffer%size
+buffer%size = buffer%size + len_s
+n = buffer%size
+
+if (n> MAX_BUFF_SIZE) then
+!!  RETURN
+!
+!  It will only affect long comments and sgml declarations
+  STOP "sax 2 Buffer overflow: long unbroken string of pcdata or attribute value..."
+endif
+
+buffer%str(last_pos+1:n) = s
+end subroutine add_str_to_buffer
+
+!----------------------------------------------------------------
+subroutine init_buffer(buffer)
+type(buffer_t), intent(inout)  :: buffer
+
+buffer%size = 0
+buffer%str=""               ! To avoid "undefined" status
+
+end subroutine init_buffer
+!----------------------------------------------------------------
+subroutine reset_buffer(buffer)
+type(buffer_t), intent(inout)  :: buffer
+  buffer%size = 0
+end subroutine reset_buffer
+!----------------------------------------------------------------
+subroutine print_buffer(buffer)
+type(buffer_t), intent(in)  :: buffer
+
+integer :: i
+
+do i = 1, buffer%size
+      write(unit=6,fmt="(a1)",advance="no") buffer%str(i:i)
+enddo
+
+end subroutine print_buffer
+!----------------------------------------------------------------
+! This is better... but could it lead to memory leaks?
+!
+function buffer_to_str(buffer) result(str)
+type(buffer_t), intent(in)          :: buffer
+character(len=buffer%size)          :: str
+
+str = buffer%str(1:buffer%size)
+end function buffer_to_str
+
+!----------------------------------------------------------------
+!
+subroutine buffer_to_character(buffer,str)
+type(buffer_t), intent(in)          :: buffer
+character(len=*), intent(out)       :: str
+
+str = buffer%str(1:buffer%size)
+end subroutine buffer_to_character
+
+!----------------------------------------------------------------
+function buffer_nearly_full(buffer) result(warn)
+type(buffer_t), intent(in)          :: buffer
+logical                             :: warn
+
+warn = buffer%size > BUFF_SIZE_WARNING
+
+end function buffer_nearly_full
+
+!----------------------------------------------------------------
+function buffer_length(buffer) result(length)
+type(buffer_t), intent(in)          :: buffer
+integer                             :: length
+
+length = buffer%size 
+
+end function buffer_length
+
+
+end module m_buffer
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_charset.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_charset.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_charset.f90	(revision 2528)
@@ -0,0 +1,203 @@
+module m_charset
+!
+! One-byte only, sorry
+!
+private
+
+integer, parameter, private  :: small_int = selected_int_kind(1)
+
+!--------------------------------------------------------------------------
+type, public :: charset_t
+! private
+      integer(kind=small_int), dimension(0:255) :: mask
+end type charset_t
+
+
+public  :: operator(.in.), operator(+)
+public  :: assignment(=)
+public  :: print_charset, reset_charset
+
+interface operator(.in.)
+      module procedure belongs
+end interface
+private :: belongs
+
+interface assignment(=)
+      module procedure set_string_to_charset, set_codes_to_charset
+end interface
+private ::  set_string_to_charset, set_codes_to_charset
+
+interface operator(+)
+      module procedure add_string_to_charset, &
+                       add_code_to_charset, add_codes_to_charset
+end interface
+private :: add_string_to_charset, add_code_to_charset, add_codes_to_charset
+
+!--------------------------------------------------------------------------
+
+character(len=*), parameter, private :: &
+            lowercase = "abcdefghijklmnopqrstuvwxyz",  & 
+            uppercase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ", &
+            digits    = "0123456789"
+
+integer, parameter, public   :: SPACE           = 32
+integer, parameter, public   :: NEWLINE         = 10
+integer, parameter, public   :: CARRIAGE_RETURN = 13
+integer, parameter, public   :: TAB             =  9
+
+type(charset_t), public    :: initial_name_chars
+type(charset_t), public    :: name_chars
+type(charset_t), public    :: whitespace
+type(charset_t), public    :: valid_chars
+type(charset_t), public    :: uppercase_chars
+
+public  :: setup_xml_charsets
+
+
+CONTAINS !==========================================================
+
+!--------------------------------------------------------------
+function belongs(c,charset)  result(res)
+character(len=1), intent(in)  :: c
+type(charset_t), intent(in)   :: charset
+logical                       :: res
+
+integer  :: code
+
+code = ichar(c)
+res = (charset%mask(code) == 1)
+
+end function belongs
+
+!--------------------------------------------------------------
+
+function add_string_to_charset(charset,str)  result (sum)
+type(charset_t), intent(in)      :: charset
+character(len=*), intent(in)     :: str
+type(charset_t)                  :: sum
+
+integer :: length, code, i
+
+sum%mask = charset%mask
+
+length = len_trim(str)
+do i = 1, length
+      code = ichar(str(i:i))
+      sum%mask(code) = 1
+enddo
+end function add_string_to_charset
+
+!--------------------------------------------------------------
+
+function add_code_to_charset(charset,code) result(sum)
+type(charset_t), intent(in)      :: charset
+integer, intent(in)              :: code
+type(charset_t)                  :: sum
+
+if ((code > 255) .or. (code < 0)) return
+sum%mask = charset%mask
+sum%mask(code) = 1
+
+end function add_code_to_charset
+
+!--------------------------------------------------------------
+function add_codes_to_charset(charset,codes) result(sum)
+type(charset_t), intent(in)        :: charset
+integer, dimension(:), intent(in)  :: codes
+type(charset_t)                    :: sum
+
+integer  :: i
+
+sum%mask = charset%mask
+do i = 1, size(codes)
+      if ((codes(i) > 255) .or. (codes(i) < 0)) cycle
+      sum%mask(codes(i)) = 1
+enddo
+end function add_codes_to_charset
+
+!--------------------------------------------------------------
+
+subroutine set_string_to_charset(charset,str)      
+type(charset_t), intent(out)   :: charset
+character(len=*), intent(in)   :: str
+
+
+integer :: length, code, i
+
+charset%mask = 0
+
+length = len_trim(str)
+do i = 1, length
+      code = ichar(str(i:i))
+      charset%mask(code) = 1
+enddo
+
+end subroutine set_string_to_charset
+
+!--------------------------------------------------------------
+
+subroutine set_codes_to_charset(charset,codes)      
+type(charset_t), intent(out)   :: charset
+integer, dimension(:), intent(in)  :: codes
+
+integer :: i
+
+charset%mask = 0
+
+do i = 1, size(codes)
+      charset%mask(codes(i)) = 1
+enddo
+
+end subroutine set_codes_to_charset
+
+
+!--------------------------------------------------------------
+subroutine print_charset(charset)      
+type(charset_t), intent(in)   :: charset
+
+integer :: i
+
+do i = 0, 255
+      if (charset%mask(i) == 1) print *, "Code: ", i
+enddo
+end subroutine print_charset
+
+!--------------------------------------------------------------
+
+subroutine reset_charset(charset)      
+type(charset_t), intent(inout)   :: charset
+
+integer :: i
+
+do i = 0, 255
+      charset%mask(i) = 0
+enddo
+end subroutine reset_charset
+
+!--------------------------------------------------------------
+
+!--------------------------------------------------------
+subroutine setup_xml_charsets()
+
+integer :: i
+
+uppercase_chars = uppercase
+initial_name_chars = (lowercase  // uppercase //  "_:" )
+name_chars = initial_name_chars + ( digits // ".-")
+whitespace = (/ SPACE, NEWLINE, TAB, CARRIAGE_RETURN /)
+
+valid_chars = whitespace + (/ (i, i=33,255) /)
+
+end subroutine setup_xml_charsets
+!--------------------------------------------------------
+
+end module m_charset
+
+
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_converters.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_converters.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_converters.f90	(revision 2528)
@@ -0,0 +1,180 @@
+module m_converters
+
+use m_debug
+
+private
+!
+! Takes a string and turns it into useful data structures,
+! such as numerical arrays.
+!
+! NOTE: The string must contain *homogeneous* data, i.e.: all real numbers,
+! all integers, etc.
+!
+public :: build_data_array
+
+interface build_data_array
+      module procedure build_data_array_real_sp,  &
+                       build_data_array_real_dp,  &
+                       build_data_array_integer
+end interface
+private :: build_data_array_real_sp
+private :: build_data_array_real_dp
+private :: build_data_array_integer
+
+private :: token_analysis, is_separator, is_CR_or_LF
+
+CONTAINS
+
+!---------------------------------------------------------------
+subroutine build_data_array_real_dp(str,x,n)
+integer, parameter  :: dp = selected_real_kind(14)
+!
+character(len=*), intent(in)                ::  str
+real(kind=dp), dimension(:), intent(inout)  ::    x
+integer, intent(inout)                      ::    n
+
+integer                            :: ntokens, status, last_pos
+character(len=len(str))  :: s
+
+s = str
+call token_analysis(s,ntokens,last_pos)
+if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
+if (debug) print *, s
+if ((n + ntokens) > size(x)) STOP "data array full"
+read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
+if (status /= 0) STOP "real conversion error"
+n = n + ntokens
+
+end subroutine build_data_array_real_dp
+!---------------------------------------------------------------
+
+subroutine build_data_array_real_sp(str,x,n)
+integer, parameter  :: sp = selected_real_kind(6)
+!
+character(len=*), intent(in)                :: str
+real(kind=sp), dimension(:), intent(inout)  ::    x
+integer, intent(inout)                      ::    n
+
+integer                            :: ntokens, status, last_pos
+character(len=len(str))  :: s
+
+s = str
+call token_analysis(s,ntokens,last_pos)
+if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
+if (debug) print *, s
+if ((n + ntokens) > size(x)) STOP "data array full"
+read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
+if (status /= 0) STOP "real conversion error"
+n = n + ntokens
+
+end subroutine build_data_array_real_sp
+
+!---------------------------------------------------------------
+subroutine build_data_array_integer(str,x,n)
+integer, parameter  :: sp = selected_real_kind(14)
+!
+character(len=*), intent(in)                :: str
+integer, dimension(:), intent(inout)        ::    x
+integer, intent(inout)                      ::    n
+
+integer                            :: ntokens, status, last_pos
+character(len=len(str))  :: s
+
+s = str
+call token_analysis(s,ntokens,last_pos)
+if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
+if (debug) print *, s
+if ((n + ntokens) > size(x)) STOP "data array full"
+read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
+if (status /= 0) STOP "integer conversion error"
+n = n + ntokens
+
+end subroutine build_data_array_integer
+
+
+!==================================================================
+
+function is_separator(c) result(sep)
+character(len=1), intent(in)          :: c
+logical                               :: sep
+
+ sep = ((c == char(32)) .or. (c == char(10))             &
+         .or. (c == char(9)) .or. (c == char(13)))
+
+end function is_separator
+!----------------------------------------------------------------
+function is_CR_or_LF(c) result(res)
+character(len=1), intent(in)          :: c
+logical                               :: res
+
+ res = ((c == char(10)) .or. (c == char(13)))
+
+end function is_CR_or_LF
+
+!==================================================================
+
+subroutine token_analysis(str,ntokens,last_pos)
+!
+character(len=*), intent(inout)          :: str
+integer, intent(out)                     :: ntokens, last_pos
+!
+!
+! Checks the contents of a string and finds the number of tokens it contains
+! The standard separator is generalized whitespace (space, tab, CR, or LF)
+! It also returns the last useful position in the string (excluding
+! separator characters which are not blanks, and thus not caught by the
+! (len_)trim fortran intrinsic). This is necessary to perform list-directed
+! I/O in the string as an internal file.
+! 
+! Also, replace on the fly CR and LF by blanks. This is necessary if
+! str spans more than one record. In that case, internal reads only 
+! look at the first record. 
+! -- ** Compiler limits on size of internal record??
+!
+integer           :: i, str_length
+logical           :: in_token
+character(len=1)  :: c
+
+in_token = .false.
+ntokens = 0
+last_pos = 0
+
+str_length = len_trim(str)
+!print *, "string length: ", str_length
+
+do i = 1, str_length
+      c = str(i:i)
+
+      if (in_token) then
+         if (is_separator(c)) then
+            in_token = .false.
+            if (is_CR_or_LF(c)) str(i:i) = " "
+         else
+            last_pos = i
+         endif
+
+      else   ! not in token
+         
+         if (is_separator(c)) then
+            if (is_CR_or_LF(c)) str(i:i) = " "
+            ! do nothing
+         else
+            in_token = .true.
+            last_pos = i
+            ntokens = ntokens + 1
+         endif
+      endif
+enddo
+!print *, "ntokens, last_pos: ", ntokens, last_pos
+
+end subroutine token_analysis
+
+
+end module m_converters
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_debug.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_debug.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_debug.f90	(revision 2528)
@@ -0,0 +1,5 @@
+module m_debug
+
+logical, public, save   :: debug = .false.
+
+end module m_debug
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_dictionary.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_dictionary.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_dictionary.f90	(revision 2528)
@@ -0,0 +1,183 @@
+module m_dictionary
+
+use m_buffer
+private
+!
+! A very rough implementation for now
+! It uses fixed-length buffers for key/value pairs,
+! and the maximum number of dictionary items is hardwired.
+
+integer, parameter, private    :: MAX_ITEMS = 64
+type, public :: dictionary_t
+private
+      integer                               :: number_of_items
+      type(buffer_t), dimension(MAX_ITEMS)  :: key
+      type(buffer_t), dimension(MAX_ITEMS)  :: value
+end type dictionary_t
+
+!
+! Building procedures
+!
+public  :: add_key_to_dict, add_value_to_dict, init_dict, reset_dict
+
+!
+! Query and extraction procedures
+!
+public  :: len
+interface len
+   module procedure number_of_entries
+end interface
+public  :: number_of_entries
+public  :: get_key
+public  :: get_value
+public  :: has_key
+public  :: print_dict
+!
+public  :: get_name
+
+interface get_name
+   module procedure get_key
+end interface
+
+interface get_value
+   module procedure sax_get_value
+end interface
+private :: sax_get_value
+
+CONTAINS
+
+!------------------------------------------------------
+function number_of_entries(dict) result(n)
+type(dictionary_t), intent(in)   :: dict
+integer                          :: n
+
+n = dict%number_of_items
+
+end function number_of_entries
+
+!------------------------------------------------------
+function has_key(dict,key) result(found)
+type(dictionary_t), intent(in)   :: dict
+character(len=*), intent(in)     :: key
+logical                          :: found
+
+integer  :: n, i
+found = .false.
+n = dict%number_of_items
+do  i = 1, n
+      if (dict%key(i) .EQUAL. key) then
+         found = .true.
+         exit
+      endif
+enddo
+end function has_key
+
+!------------------------------------------------------
+subroutine sax_get_value(dict,key,value,status)
+type(dictionary_t), intent(in)            :: dict
+character(len=*), intent(in)              :: key
+character(len=*), intent(out)             :: value
+integer, intent(out)                      :: status
+!
+integer  :: n, i
+
+status = -1
+n = dict%number_of_items
+do  i = 1, n
+      if (dict%key(i) .EQUAL. key) then
+         value = str(dict%value(i))
+         status = 0
+         RETURN
+      endif
+enddo
+
+end subroutine sax_get_value
+
+!------------------------------------------------------
+subroutine get_key(dict,i,key,status)
+!
+! Get the i'th key
+!
+type(dictionary_t), intent(in)            :: dict
+integer, intent(in)                       :: i
+character(len=*), intent(out)             :: key
+integer, intent(out)                      :: status
+
+if (i <= dict%number_of_items) then
+      key = str(dict%key(i))
+      status = 0
+else
+      key = ""
+      status = -1
+endif
+
+end subroutine get_key
+
+!------------------------------------------------------
+subroutine add_key_to_dict(key,dict)
+type(buffer_t), intent(in)          :: key
+type(dictionary_t), intent(inout)   :: dict
+
+integer  :: n
+
+n = dict%number_of_items
+if (n == MAX_ITEMS) then
+      write(unit=0,fmt=*) "Dictionary capacity exceeded ! size= ", max_items
+      RETURN
+endif
+
+n = n + 1
+dict%key(n) = key
+dict%number_of_items = n
+
+end subroutine add_key_to_dict
+
+!------------------------------------------------------
+! Assumes we build the dictionary in an orderly fashion,
+! so one adds first the key and then immediately afterwards the value.
+!
+subroutine add_value_to_dict(value,dict)
+type(buffer_t), intent(in)          :: value
+type(dictionary_t), intent(inout)   :: dict
+
+integer  :: n
+
+n = dict%number_of_items
+dict%value(n) = value
+
+end subroutine add_value_to_dict
+
+!------------------------------------------------------
+subroutine init_dict(dict)
+type(dictionary_t), intent(inout)   :: dict
+
+integer  :: i
+
+dict%number_of_items = 0
+do i=1, MAX_ITEMS                      ! To avoid "undefined" status
+   call init_buffer(dict%key(i))       ! (Fortran90 restriction)
+   call init_buffer(dict%value(i))
+enddo
+end subroutine init_dict
+!------------------------------------------------------
+subroutine reset_dict(dict)
+type(dictionary_t), intent(inout)   :: dict
+
+dict%number_of_items = 0
+
+end subroutine reset_dict
+
+!------------------------------------------------------
+subroutine print_dict(dict)
+type(dictionary_t), intent(in)   :: dict
+
+integer  :: i
+
+do i = 1, dict%number_of_items
+      print *, trim(str(dict%key(i))), " = ", trim(str(dict%value(i)))
+enddo
+
+end subroutine print_dict
+
+
+end module m_dictionary
